Package org.apache.commons.collections4.iterators

# Class LoopingListIterator<E>

java.lang.Object
org.apache.commons.collections4.iterators.LoopingListIterator<E>

Type Parameters:
  `E` - the type of elements returned by this iterator.

All Implemented Interfaces:
  `Iterator<E>`, `ListIterator<E>`, `OrderedIterator<E>`, `ResettableIterator<E>`, `ResettableListIterator<E>`

public class LoopingListIterator<E> extends Object implements ResettableListIterator<E>
A ListIterator that restarts when it reaches the end or when it reaches the beginning.

The iterator will loop continuously around the provided list, unless there are no elements in the collection to begin with, or all of the elements have been `removed`.

Concurrent modifications are not directly supported, and for most collection implementations will throw a ConcurrentModificationException.

Since:
  3.2

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LoopingListIterator(List<E> list)`
  Constructor that wraps a list.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(E obj)`
  Inserts the specified element into the underlying list.
  `boolean`
  `hasNext()`
  Returns whether this iterator has any more elements.
  `boolean`
  `hasPrevious()`
  Returns whether this iterator has any more previous elements.
  `E`
  `next()`
  Returns the next object in the list.
  `int`
  `nextIndex()`
  Returns the index of the element that would be returned by a subsequent call to `next()`.
  `E`
  `previous()`
  Returns the previous object in the list.
  `int`
  `previousIndex()`
  Returns the index of the element that would be returned by a subsequent call to `previous()`.
  `void`
  `remove()`
  Removes the previously retrieved item from the underlying list.
  `void`
  `reset()`
  Resets the iterator back to the start of the list.
  `void`
  `set(E obj)`
  Replaces the last element that was returned by `next()` or `previous()`.
  `int`
  `size()`
  Gets the size of the list underlying the iterator.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.util.Iterator

  `forEachRemaining`

- ## Constructor Details

  - ### LoopingListIterator

    public LoopingListIterator(List<E> list)
    Constructor that wraps a list.

    There is no way to reset a ListIterator instance without recreating it from the original source, so the List must be passed in and a reference to it held.

    Parameters:
      `list` - the list to wrap
    Throws:
      `NullPointerException` - if the list is null

- ## Method Details

  - ### add

    public void add(E obj)
    Inserts the specified element into the underlying list.

    The element is inserted before the next element that would be returned by `next()`, if any, and after the next element that would be returned by `previous()`, if any.

    This feature is only supported if the underlying list's `List.listIterator()` method returns an implementation that supports it.

    Specified by:
      `add` in interface `ListIterator<E>`
    Parameters:
      `obj` - the element to insert
    Throws:
      `UnsupportedOperationException` - if the add method is not supported by the iterator implementation of the underlying list

  - ### hasNext

    public boolean hasNext()
    Returns whether this iterator has any more elements.

    Returns false only if the list originally had zero elements, or all elements have been `removed`.

    Specified by:
      `hasNext` in interface `Iterator<E>`
    Specified by:
      `hasNext` in interface `ListIterator<E>`
    Returns:
      `true` if there are more elements

  - ### hasPrevious

    public boolean hasPrevious()
    Returns whether this iterator has any more previous elements.

    Returns false only if the list originally had zero elements, or all elements have been `removed`.

    Specified by:
      `hasPrevious` in interface `ListIterator<E>`
    Specified by:
      `hasPrevious` in interface `OrderedIterator<E>`
    Returns:
      `true` if there are more elements

  - ### next

    public E next()
    Returns the next object in the list.

    If at the end of the list, returns the first element.

    Specified by:
      `next` in interface `Iterator<E>`
    Specified by:
      `next` in interface `ListIterator<E>`
    Returns:
      the object after the last element returned
    Throws:
      `NoSuchElementException` - if there are no elements in the list

  - ### nextIndex

    public int nextIndex()
    Returns the index of the element that would be returned by a subsequent call to `next()`.

    As would be expected, if the iterator is at the physical end of the underlying list, 0 is returned, signifying the beginning of the list.

    Specified by:
      `nextIndex` in interface `ListIterator<E>`
    Returns:
      the index of the element that would be returned if next() were called
    Throws:
      `NoSuchElementException` - if there are no elements in the list

  - ### previous

    public E previous()
    Returns the previous object in the list.

    If at the beginning of the list, return the last element. Note that in this case, traversal to find that element takes linear time.

    Specified by:
      `previous` in interface `ListIterator<E>`
    Specified by:
      `previous` in interface `OrderedIterator<E>`
    Returns:
      the object before the last element returned
    Throws:
      `NoSuchElementException` - if there are no elements in the list

  - ### previousIndex

    public int previousIndex()
    Returns the index of the element that would be returned by a subsequent call to `previous()`.

    As would be expected, if at the iterator is at the physical beginning of the underlying list, the list's size minus one is returned, signifying the end of the list.

    Specified by:
      `previousIndex` in interface `ListIterator<E>`
    Returns:
      the index of the element that would be returned if previous() were called
    Throws:
      `NoSuchElementException` - if there are no elements in the list

  - ### remove

    public void remove()
    Removes the previously retrieved item from the underlying list.

    This feature is only supported if the underlying list's `iterator` method returns an implementation that supports it.

    This method can only be called after at least one `next()` or `previous()` method call. After a removal, the remove method may not be called again until another `next()` or `previous()` has been performed. If the `reset()` is called, then remove may not be called until `next()` or `previous()` is called again.

    Specified by:
      `remove` in interface `Iterator<E>`
    Specified by:
      `remove` in interface `ListIterator<E>`
    Throws:
      `UnsupportedOperationException` - if the remove method is not supported by the iterator implementation of the underlying list

  - ### reset

    public void reset()
    Resets the iterator back to the start of the list.
    Specified by:
      `reset` in interface `ResettableIterator<E>`

  - ### set

    public void set(E obj)
    Replaces the last element that was returned by `next()` or `previous()`.

    This feature is only supported if the underlying list's `List.listIterator()` method returns an implementation that supports it.

    Specified by:
      `set` in interface `ListIterator<E>`
    Parameters:
      `obj` - the element with which to replace the last element returned
    Throws:
      `UnsupportedOperationException` - if the set method is not supported by the iterator implementation of the underlying list

  - ### size

    public int size()
    Gets the size of the list underlying the iterator.
    Returns:
      the current list size